// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
//
//

/** @author Kristofer Johannisson */

package de.uka.ilkd.key.ocl.gf;

import de.uka.ilkd.key.casetool.ReprModelMethod;

/** the GF editor uses this class as an interface for sending pre-/postconditions
  * to Together */
public class CallbackPrePost
{
	private ReprModelMethod rmm; 

	public CallbackPrePost(ReprModelMethod rmm)
	{
		this.rmm = rmm;
	}
	
	public void sendPrePost(String abs, String preOCL, String postOCL)
	{
		System.out.println("sendPrePost received");
		System.out.println("    abs:" + abs);
		System.out.println("    pre:" + preOCL);
		System.out.println("    post:" + postOCL);

		rmm.setMyGFAbs(abs);
		rmm.setMyPreCond(preOCL);
		rmm.setMyPostCond(postOCL);
	}
}
