// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
/* Generated by Together */

package de.uka.ilkd.key.ocl.ocldltranslator;

import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.op.Modality;
import de.uka.ilkd.key.logic.op.ProgramVariable;
import tudresden.ocl.*;
import de.uka.ilkd.key.ProverFacade;
import de.uka.ilkd.key.casetool.ReprModelMethod;

public class OCLTreeToDLAggregator {
    protected ProverFacade proverFacade;
    protected ReprModelMethod methodContext;
    protected ProgramVariable[] methodParameters;

    public OCLTreeToDLAggregator(ProverFacade facade){
    	this.proverFacade = facade;
    }


    public OCLTreeToDLAggregator(ProverFacade facade, 
				 ReprModelMethod method) {
    	this(facade);
	methodContext = method;
    }


    public ProgramVariable[] getMethodParameters() {
	return methodParameters;
    }

    public Term treeToTerm(OclTree tree, boolean diamondForm, boolean ignorePost,
                           Modality modality){
	KeyOclConstraintTranslator aTranslator = 
	    new KeyOclConstraintTranslator(proverFacade, methodContext);
        KeyTranslationResult aRes;
	de.uka.ilkd.key.util.Debug.out("start OCL->DL translation");
        aRes = (KeyTranslationResult) aTranslator.
	    getTranslationFor(tree, diamondForm, ignorePost, modality);
	de.uka.ilkd.key.util.Debug.out("finished OCL->DL translation");
	methodParameters = aTranslator.getMethodParameters();
	return aRes.getTerm();
    }
    
    public Term treeToTerm(OclTree tree, boolean diamondForm, 
            boolean ignorePost){
         return treeToTerm(tree, diamondForm, ignorePost, null);
    }
}
