// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof;

/**
 * StrategyChangeListener defines the interface of an
 * object that watches the currently used strategy.
 * At the moment, strategies are selected on a per proof
 * basis.
 */
public interface AutoModeConfigurationListener {
    /**
     * Invoked if the strategy has changed.
     */
    void strategyChanged ( AutoModeConfiguration config );
    
    /**
     * Invoked if the maximum number of rule applications
     * alowed in automatic mode has changed.
     */
    void maxAutomaticStepsChanged ( AutoModeConfiguration config );
}
