// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.proof;



/** Proof-specific counter object: taclet names, var names, node numbers, &c */
public class Counter {

    private String name;
    private int count;
    
    private ListOfNode undoAnchors = SLListOfNode.EMPTY_LIST;

    public Counter(String name) {
        this.name=name;
    }
    
    public int getCount() {
        return count;
    }

/*
    public int getCountPlusPlus() {
        return count++;
    }
*/

    public int getCountPlusPlus(Node undoAnchor) {
        undoAnchors = undoAnchors.prepend(undoAnchor);
        return count++;
    }
    
    public void undo(Node node) {
        if (undoAnchors.head() == node) {
            undoAnchors = undoAnchors.tail();
            count--;
        }
    }

}
