// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.proof.init;

import de.uka.ilkd.key.parser.jml.*;
import de.uka.ilkd.key.java.declaration.MethodDeclaration;
import de.uka.ilkd.key.jml.*;
import de.uka.ilkd.key.proof.mgt.*;
import de.uka.ilkd.key.collection.*;
import de.uka.ilkd.key.proof.*;
import de.uka.ilkd.key.logic.Term;

public class JMLPostPO extends JMLProofOblInputImpl{

    private Term po = null;

    public JMLPostPO(JMLMethodSpec spec, String javaPath, boolean allInv){
	super(spec, javaPath, allInv);
	md = spec.getMethodDeclaration();
    }

    public ProofList getPO(){
	return new ProofList(
	    new Proof(name(),
		      (Term) po,
		      createProblemHeader(),
		      initConfig.createTacletIndex(), 
		      initConfig.createBuiltInRuleIndex(),
		      initConfig.getActivatedChoices()), name());
    }

    public void readProblem(ModStrategy mod) throws ProofInputException{
	initConfig.progVarNS().add(initConfig.getServices().
				   getImplementation2SpecMap().getProgVarNS());
	initConfig.progVarNS().add(UsefulTools.buildParamNamespace(md));
	po = ((JMLMethodSpec) spec).createDLFormula(false, allInv);
    }
    
    public boolean checkPurity(){
	return UsefulTools.purityCheck((JMLMethodSpec) spec, 
				       initConfig.getServices().
				       getImplementation2SpecMap()) == null;
    }

    public String name(){
	return "Ensures Post Condition PO (using "+
	    (allInv ? "all invariants" : "only invariants from "+
	     ((JMLMethodSpec) spec).getClassDeclaration().getName())+
	    " for the precondition) Condition PO for:\n "+spec.toString();
    }

}
