// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.Namespace;
import de.uka.ilkd.key.logic.SetOfTerm;
import de.uka.ilkd.key.java.statement.MethodBodyStatement;
import de.uka.ilkd.key.casetool.ReprModelMethod;

public class DLMethodContract extends DLHoareTripleContract 
                              implements MethodContract {

    ReprModelMethod meth;

    public DLMethodContract(Term fma, SetOfTerm modifies, Namespace heurNS) {
	super(fma, modifies, heurNS, "DL", null);
	meth = new JavaModelMethod
	    (((MethodBodyStatement)getStatement()).getProgramMethod(),""); //%%%
    }

    public String toString() {
	return "DL Method Contract "+fma;
    }

    public Object getObjectOfContract() {
	return getModelMethod();
    }

    public ReprModelMethod getModelMethod() {
	return meth;
    }

}
