// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.proof.*;
import de.uka.ilkd.key.rule.Rule;
import de.uka.ilkd.key.rule.RuleApp;
import de.uka.ilkd.key.gui.KeYMediator;
import java.util.Iterator;

public interface ProofCorrectnessMgt {

    boolean ruleApplicable(RuleApp r, Goal g);

    String getLastAnalysisInfo();

    ProofStatus getStatus();

    void updateProofStatus();
    
    void ruleApplied(Rule r);

    void ruleUnApplied(Rule r);
    
    boolean usesNonAxiom(Rule r);

    Iterator getAppliedNonAxioms();

    void setMediator ( KeYMediator p_mediator );

    boolean proofSimilarTo(Proof p);

    RuleJustification getJustification(RuleApp app);

}
