// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.Node;
import de.uka.ilkd.key.proof.ProofList;
import de.uka.ilkd.key.rule.Rule;
import de.uka.ilkd.key.rule.RuleApp;
import java.util.*;

public class RuleJustificationByAddRules implements RuleJustification{

    private Node node;

    public RuleJustificationByAddRules(Node node) {
	this.node = node;
    }
    
    public List getProofList() {
	return new LinkedList();
    }

    public DepAnalysis dependsOn(Proof p) {
	return DepAnalysis.getInstance(false, null, p); //correctness ensured
	                                                //by taclet mechanism
    }
    
    public boolean isAxiomJustification() {
	return true;
    }

    public RuleApp motherTaclet() {
	return node.getAppliedRuleApp();
    }

    public String toString() {
	return "rule justified by addrules of "+motherTaclet();
    }

}
