// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.ProofList;
import de.uka.ilkd.key.rule.Rule;
import java.util.*;

public class RuleJustificationByMethodSpec extends LemmaRuleJustification{

    private Contract ct;

    public RuleJustificationByMethodSpec(Contract ms) {
	this.ct = ms;
    }

    public Contract getMethodContract() {
	return ct;
    }
    
    public List getProofList() {
	return getMethodContract().getProofs();
    }


    public String toString() {
	return "rule justified by specification "+ct;
    }

}
