// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** this class is used to realize a pair of Sequent and RuleIndex */
package de.uka.ilkd.key.rule;
import de.uka.ilkd.key.proof.TacletIndex;
import de.uka.ilkd.key.logic.Sequent;

public class ApplyResult {
    /** the sequent */
    private Sequent seq;
    /** the ruleindex */
    private TacletIndex ruleIdx;

    /** creates a new pair of a sequent and a ruleindex
     * @param seq the Sequent being first part of the pair
     * @param ruleIdx the RuleIndex as second part
     */
    public ApplyResult(Sequent seq, TacletIndex ruleIdx) {
	this.seq=seq;
	this.ruleIdx=ruleIdx;
    } 

    /** call this method to get the sequent stored in this object 
     * @return Sequent being the first part of the pair
     */
    public Sequent seq() {
	return seq;
    } 

    /** call this method to get the ruleindex stored in this object 
     * @return RuleIndex being the second part of the pair
     */
    public TacletIndex ruleIndex() {
	return ruleIdx;
    } 
   
    /** toString */
    public String toString() {
	return "("+seq()+", "+ruleIndex()+")";
    } 

} 
