// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 16.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uka.ilkd.key.rule;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.rule.updatesimplifier.Update;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public interface IUpdateRule {
    /**
     * determines whether this rule is applicable for the pair of
     * update and target (the term on which the update will be
     * applied) term
     * @param update the Update to be applied on the given term
     * @param target the Term on which the update is applied
     * @return true if the rule can be applied on the update, target
     * pair 
     */
    public abstract boolean isApplicable(Update update, Term target);

    /**
     * applies the update on the target term 
     * @param update the Update to be applied on target
     * @param target the Term on which the update is applied
     * @return the Term resulting from the update on the target 
     */
    public abstract Term apply(Update update, Term target);
}
