// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 22.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uka.ilkd.key.rule.metaconstruct;

import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.op.*;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.rule.MatchConditions;
import de.uka.ilkd.key.rule.inst.SVInstantiations;
import de.uka.ilkd.key.proof.VariableNameProposal;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class IntroduceNewAnonymousUpdateOp implements MetaOperator{

    private final Name name = new Name("#introduceNewAnonymousUpdate");

    /**
     * 
     */
    public IntroduceNewAnonymousUpdateOp() {
        super();        
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.MetaOperator#calculate(de.uka.ilkd.key.logic.Term, de.uka.ilkd.key.rule.inst.SVInstantiations, de.uka.ilkd.key.java.Services)
     */
    public Term calculate(Term term, SVInstantiations svInst, Services services) {    
	Term assignables = term.sub(0);
	ListOfTerm lt = SLListOfTerm.EMPTY_LIST.append(term.sub(1));
	ListOfLocation locs = SLListOfLocation.EMPTY_LIST;
	while(assignables != null){
	    Term loc;
	    if(assignables.op() instanceof ListOp){
		loc = assignables.sub(0);
		assignables = assignables.sub(1);
	    }else{
		loc = assignables;
		assignables = null;
	    }
	    if(loc.op() == Op.EVERYTHING){
		return TermFactory.DEFAULT.
		    createUpdateTerm(AnonymousUpdate.
				     getNewAnonymousOperator(), 
				     new Term[]{term.sub(1)});
	    }else if(loc.op() != Op.NOTHING){
		String cname = loc.op().name().toString();
		cname = cname.substring(cname.indexOf(".")+1);
		cname = VariableNameProposal.
		    getNameProposalForDependingVariable(cname);
		Function c = new Function(new Name(cname),
					  loc.sort(),
					  new Sort[0]);
		Term con = TermFactory.DEFAULT.createFunctionTerm(c);
		lt = lt.prepend(con);
		locs = locs.prepend((Location) loc.op());
		for(int i = 0; i< loc.arity(); i++){
		    lt = lt.prepend(loc.sub(0));
		}
	    }
	}
	return TermFactory.DEFAULT.createUpdateTerm(locs.toArray(), 
						    lt.toArray());
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.Operator#name()
     */
    public Name name() {
        return name;
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.Operator#validTopLevel(de.uka.ilkd.key.logic.Term)
     */
    public boolean validTopLevel(Term term) {        
        return term.arity()==2 && term.sub(1).sort()==Sort.FORMULA;
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.Operator#sort(de.uka.ilkd.key.logic.Term[])
     */
    public Sort sort(Term[] term) {        
        return term[1].sort();
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.Operator#arity()
     */
    public int arity() {
        return 2;
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.logic.op.Operator#isRigid(de.uka.ilkd.key.logic.Term)
     */
    public boolean isRigid(Term term) {
        return false;
    }
    
    /** (non-Javadoc)
     * by default meta operators do not match anything 
     * @see de.uka.ilkd.key.logic.op.Operator#match(Operator, de.uka.ilkd.key.rule.MatchConditions, de.uka.ilkd.key.java.Services)
     */
    public MatchConditions match(Operator op, MatchConditions mc,
            Services services) {
        return null;
    }

}
