// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 26.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uka.ilkd.key.rule.updatesimplifier;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.op.ArrayOfQuantifiableVariable;
import de.uka.ilkd.key.logic.op.NonRigid;
import de.uka.ilkd.key.rule.AbstractUpdateRule;
import de.uka.ilkd.key.rule.UpdateSimplifier;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ApplyOnRigidOperatorTerm extends AbstractUpdateRule {

    /**
     * @param updateSimplifier
     */
    public ApplyOnRigidOperatorTerm(UpdateSimplifier us) {
        super(us);   
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.rule.UpdateRule#isApplicable(de.uka.ilkd.key.rule.updatesimplifier.Update, de.uka.ilkd.key.logic.Term)
     */
    public boolean isApplicable(Update update, Term target) {        
        return !(target.op() instanceof NonRigid);
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.uka.ilkd.key.rule.UpdateRule#apply(de.uka.ilkd.key.rule.updatesimplifier.Update,
     *      de.uka.ilkd.key.logic.Term)
     */
    public Term apply(Update update, Term target) {
        final Term result;
                
        final PropagationResult pr = propagateUpdateToSubterms(update, target);        
        final Term[] subs = pr.getSimplifiedSubterms();
        final ArrayOfQuantifiableVariable[] vars = pr.getBoundVariables();
             
        if (pr.hasChanged()) {
            result = UpdateSimplifierTermFactory.DEFAULT.getBasicTermFactory().
            createTerm(target.op(), subs, vars, target.javaBlock(), 
                       target.ruleVar());           
        } else  {
            result = target;
        }
        
        return result;
    }
}
