package javacard.framework;

public final class JCSystem {

    public static final byte NOT_A_TRANSIENT_OBJECT = 0;
    public static final byte CLEAR_ON_RESET = 1;
    public static final byte CLEAR_ON_DESELECT = 2;

    private static byte transactionDepth;

    public static byte isTransient(Object theObj){
	return jvmIsTransient(theObj);
    }

    public static native byte jvmIsTransient(Object theObj);

    public static boolean[] makeTransientBooleanArray(short length, 
        byte event) {
          // Check the parameters here!!!
  	  return jvmMakeTransientBooleanArray(length, event);
	}

    public static native boolean[] jvmMakeTransientBooleanArray(short length, 
        byte event);

    public static byte[] makeTransientByteArray(short length,
	byte event) {
          // Check the parameters here!!!
	  return jvmMakeTransientByteArray(length, event);
    }

    public static native byte[] jvmMakeTransientByteArray(short length,
	byte event);
    
    public static short[] makeTransientShortArray(short length, 
	byte event) {
	  // Check the parameters here!!!
  	  return jvmMakeTransientShortArray(length, event);
    }

    public static native short[] jvmMakeTransientShortArray(short length,
        byte event);
    

    public static Object[] makeTransientObjectArray(short length,
	byte event) {
          // Check the parameters here!!!
  	  return jvmMakeTransientObjectArray(length, event);
    }

    public static native Object[] jvmMakeTransientObjectArray(short length,
	byte event);
    
    public static void beginTransaction() throws TransactionException {
	if(transactionDepth > (byte)0)
	    TransactionException.throwIt(TransactionException.IN_PROGRESS);
	transactionDepth++;
	JCSystem.jvmBeginTransaction();
    }
 
    public static void abortTransaction() throws TransactionException {
	if(transactionDepth == (byte)0)
	    TransactionException.throwIt(TransactionException.NOT_IN_PROGRESS);
	transactionDepth--;
	JCSystem.jvmAbortTransaction();
    }

    public static void commitTransaction() throws TransactionException {
	if(transactionDepth == (byte)0)
	    TransactionException.throwIt(TransactionException.NOT_IN_PROGRESS);
	transactionDepth--;
	JCSystem.jvmCommitTransaction();
    }
    
    public static native void jvmBeginTransaction();
    public static native void jvmAbortTransaction();
    public static native void jvmCommitTransaction();

    public static byte getTransactionDepth() {
	return transactionDepth;
    }
} 
