package paycard;

public class PayCard {

    /*@ spec_public @*/ int limit=1000;
    /*@ spec_public @*/ int unsuccessfulOperations;
    /*@ spec_public @*/ int id;
    /*@ spec_public @*/ int balance=0;

    public /*@pure@*/ PayCard(int limit) {
        balance = 0;
        unsuccessfulOperations=0;
        this.limit=limit;
    }

    public /*@pure@*/ PayCard() {
		balance=0;
        unsuccessfulOperations=0;
    }

    /*@
      public normal_behavior
       requires amount>0 ;
       assignable unsuccessfulOperations, balance;
       ensures balance >= \old(balance);
      @*/
   public void charge(int amount) {
        if (this.balance+amount>=this.limit) {
            this.unsuccessfulOperations++;
        } else {
            this.balance=this.balance+amount;
        }
    }

    /*@
      public normal_behavior
       requires true;
       ensures \result == balance || unsuccessfulOperations > 3;
      @*/
    public /*@pure@*/ int available() {
	if (unsuccessfulOperations<=3) {
	    return this.balance;
        }
        return 0;
    }

    public String infoCardMsg() {
	return (" Current balance on card is " + balance);
    }

    //@ requires 0==0;
    public int test(){
	int i=5;
	//@ loop_invariant i>=0;
	//@ assignable i;
	while(i>0){
	    i--;
	}
    }
}
